'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUM C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO als Code-Schalter,
' z.B. als Zugangsberechtigung zum  Khlschrank.
' Das Relais schaltet, wenn der richtige Klingelcode ( hier: kurz-kurz-kurz-lang-lang)
' eingegeben wird.  
' Kurz / lang sind hier zu 0 - 300ms bzw.  300ms - 1s definiert, das System wird zurckgesetzt,
' wenn zwischen den Tastendrucken mehr als 1s verstreicht
' Das Programm kann natrlich an beliebige Codes (mit beliebiger Lnge)  angepasst werden

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define LED      port[5]
define BUTTON   port[3]
'-------- PROGRAMM START --------
define RINGCOUNTER  byte[1]
define MATCHCOUNTER byte[2]
define CODE         byte[3]

#LOOP
if TIMER=49 then goto RESET
if BUTTON then goto LOOP
SECOND=0
'--- GET THE KEY PRESS DURATION ----
#GET_KEYPRESS
wait BUTTON:RINGCOUNTER=RINGCOUNTER+1
'---- CHECK FOR MATCHING -----------
looktab CODETAB,RINGCOUNTER,CODE
'---- MATCHING A LONG PRESS? ---------
if ((TIMER > 15) and (TIMER<CODE))then goto MATCH
'---- MATCHING A SHORT PRESS ? ------
if ((TIMER < 15) and (TIMER>CODE))then goto MATCH
'--- NO MATCH FOUND RESET ALL AFTER 5 RINGS ------------
MATCHCOUNTER=0:if RINGCOUNTER=5 then RINGCOUNTER=0
GOTO LOOP
'-------------------------------------------------------
#MATCH
MATCHCOUNTER=MATCHCOUNTER+1
if (RINGCOUNTER=5) and (MATCHCOUNTER=5) then goto OPEN
goto LOOP
#OPEN
RINGCOUNTER=0:MATCHCOUNTER=0:LED=on:pause 50:LED=off:goto LOOP
#RESET
RINGCOUNTER=0:MATCHCOUNTER=0:LED=off:goto LOOP
'-------------------------------------------------------
table CODETAB 0 1 1 1 50 50

tabend
