'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUM C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO als IR-Schalter,
' z.B. als Fernsteuerung fr ein Garagentor.
' Sie knnen dafr eine handelsbliche Fernsteuerung nehmen, die RC5 codiert ist.
' Die gesendeten Codes Ihrer Fernsteuerung knnen Sie anzeigen lassen,
' wenn Sie die Variablen COMMAND und ADDRESS mit PRINT an das Hyperterminal schicken
' Das Relais schaltet, EIN/AUS wenn der richtige RC 5 IR-Code empfangen wurde
' Hier: Adresse 0, Command 32 -> EIN
'       Adresse 0, Command 33 -> AUS
' Das Programm kann natrlich an beliebige Codes  angepasst werden, auch eine Erweiterung auf bis zu
' 4 Kanle ist schnell zu realisieren.
' Ebenso kann natrlich das Schaltverhalten dem Zweck angepasst werden.
' Der Treiber stellt in den Variablen COMMAND und ADDRESS die Empfangenen Daten bereit.
'---------------------------------------------------------------------------
'
' !!!  DER TREIBER PASST NICHT ZUR MICRO MIT BETRIEBSSYSTEM-VERSION V 2.00 !!!
'
' Ein Tool um die OS-Version festzustellen finden Sie im Verzeichnis MICRO_TOOLS
'----------------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define IRIN      port[4]
define LED       port[5]
define BUTTON    port[3]
'-------- PROGRAMM START --------
define COMMAND   byte[1]
define ADDRESS   byte[2]

baud 9600

SYS &HFD06 'ENABLE BACKGROUND RECEIVING

#loop
'----- WAITING FOR RECEIVED DATA -------
wait (COMMAND or ADDRESS)<>0
'print COMMAND
'print ADDRESS
'----- DELETE TOGGLE BIT ---------------
ADDRESS=ADDRESS and &H1F
if ADDRESS = 0 then goto CLEAR_DATA
if COMMAND=32 then goto OPEN
if COMMAND=33 then goto CLOSE
goto CLEAR_DATA
'---------------------------------------
#CLOSE
LED=off:goto CLEAR_DATA
'---------------------------------------
#OPEN
LED=on:goto CLEAR_DATA
'---------------------------------------
#CLEAR_DATA
COMMAND=0:ADDRESS=0:goto LOOP

SYSCODE "RC5_P0.s19"
