'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUM C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'
'-----------------------------------------------------------------------
' THEMA: DIGITALPORTS ALS SERIELLE SCHNITTSTELLE
'        PRINT
'        GOSUB
'-----------------------------------------------------------------------
' Beispiel zur C-Control MICRO mit dem Programmer/Application-Board (P/A-BOARD)
' Die C-Control MICRO hat sechs Ports die, auch innerhalb eines Programms,
' verschiedene Funktionen erfllen. Der Port 1 kann als TXD einer seriellen
' Schnittstelle dienen.
' Ein Empfang von Daten ist ber das Schlsselwort PUT vorgesehen.
' Auf dem P/A-BOARD ist der Port 1 u. 2 bereits mit dem richtigen Pin des
' Schnittstellensteckers verbunden.
' Sie brauchen also nur ein Terminalprogramm auf dem PC zu starten, um die Ausgaben
' der C-Control zu lesen.
' Um die Schnittstelle zu aktivieren muss zuerst die Baudrate definiert werden.
' BAUD 9600 oder BAUD 19200 (andere Baudraten weden nicht bercksichtigt)
' Damit wird der PORT gleichzeitig als OUTPUT geschaltet
' Die Schnittstellenfunktion schalten Sie mit DEACT ab.
'
'-------------------------------------------------------------------------
' Achtung !
' Das P/E-Board untersttzt 19200 Baud aus technischen Grnden nicht
' (Zeitkonstanten im Pegelwandler)
' Wenn sie das P/E Board bei empfangsbereiten Terminalprogramm einschalten,
' werden einige "wirre" Zeichen angezeigt, da sich die Betriebsspannung
' erst stabilisieren muss und der Pegel am seriellen Eingang des PC nicht
' definiert ist
'------------------------------------------------------------------------


'--------------------------
'------ I/O PORTS ---------
'--------------------------
define LED      port[5]
define TASTER   port[3]
define TXD      port[1]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define COUNTS   byte[1]


BAUD 9600:pause 10
'--------------------------------------------------
'          USING PORT1 AS SERIAL OUTPUT           -
'--------------------------------------------------
print "WIR ZAEHLEN TASTENDRUCKE"
PRINT "- BITTE TASTER DRUECKEN -"
#WAIT
if TASTER=off then gosub COUNT
goto WAIT

#COUNT
COUNTS=COUNTS+1:print COUNTS
#WAIT_RELEASE
if TASTER=off then goto WAIT_RELEASE
return

