'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' CONRAD ELECRONIC 9.03 (by DIE HARD)
'-----------------------------------------------------------------------
' THEMA: ANALOGPORTS BEEPER
'-----------------------------------------------------------------------

'-----------------------------------------------------------------------
' Hier zeigen wir Ihnen wie man die Mglichkeiten der CC1 MICRO voll
' ausschpfen kann, indem man einen Port mehrfach nutzt.
' Hier wird der ADC6 bemeinsam mit einem BEEPER an diesem Port betrieben.
' Das Programm aktiviert nach berschreiten einer bestimmten Spannung an ADC6
' (hier etwa 2V)die LED und den BEEPER. Drehen Sie am Poti um die Funktion zu
' prfen. Drehen gegen den Uhreigersinn vergrssert die Spannung.
'------------------------------------------------------------------------
' Fr einen gleichzeitigen Gebrauch mehrerer Portfunktionen ist
' es absolut erforderlich auch ber die Verhaltensweise der angeschlossenen
' Harware Bescheid zu wissen.
'
' FUNKTION DES BETRIEBSSYSTEMS:
' BEEP schaltet den angesprochenen Port auf OUTPUT und belsst ihn nach dem
' BEEP auf LOW
' Das Lesen eines ADC schaltet diesen Port auf INPUT und stellt danach die
' ursprngliche Funktion wieder ein.
'
' REAKTION DER HARDWARE:
' Werden nach einem Beep keine weiteren Massnahmen ergriffen ergibt sich folgender
' Ablauf:
' 1) Der PORT ist OUTPUT und LOW
' 2) Der ADC schaltet den PORT auf INPUT und misst die Spannung.
' 3) Die Spannung steigt an dem Port allerdings nicht sofort, sondern hat durch
'    das Poti (das die Spannung erzeugt)und der Kapazitt des BEEPERS eine grosse
'    Zeitkonstante. Das fhrt zu einer falschen Messung.
' 4) Das Ansteigen der Spannung fhrt zu einem Ticken im BEEPER bei jeder Messung.
'
' MASSNAHMEN IM PROGRAMM:
' Es wird deshalb nach jedem Beep der PORT auf INPUT geschaltet und mit der Pause
' abgewartet bis die Spannung an dem Port auf den endgltigen Wert gestiegen ist.
' Erst danach ist eine Messung des ADC richtig. Das Ticken verschwindet, da der
' Port nach dem BEEP sofort als INPUT geschaltet wird
'--------------------------------------------------------------------------
' Stecken Sie bitte die Jumper JP2 und JP1 (auf Position 1-2)damit die Demo korrekt
' funktioniert.
'--------------------------------------------------------------------------

'

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define COUNTER  byte[1]
define STOP     byte[2]
define LED      port[5]
define BEEPER   port[6]
define ADC1     ad[1]
define ADC2     ad[2]
define ADC5     ad[5]
define ADC6     ad[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------


'--------------------------------------------------
'  SHARING A PORT FOR BEEPING AND AD-CONVERTER    -
'--------------------------------------------------
#START
if ADC6>100 then gosub beeping
if ADC6>100 then LED=on
if ADC6<100 then LED=off
goto START
#beeping
BEEP 100,5,BEEPER:deact BEEPER:pause 10:return





