'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII     DEMO ZUR MICRO - SYSTEMERWEITERUNG  EXTENSION 1    IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' by DIE HARD
'--------------------------------------------------------------------
'
'
'--------------------------------------------------------------------
' ERWEITERUNG:    EXT1 BASIC-SYSTEMERWEITERUNG DCF-SYNCHRONISATION  -
'                 RXD                                               -
'--------------------------------------------------------------------
' Diese Demo ladet die BASIC-SYSTEMERWEITERUNG "PAGE0_EXT1.S19"
' und zeigt wie die RTC der MICRO mit einer DCF-Uhr synchronisiert wird.
' Der Aufruf SYS  DCFSYNC startet die Synchronisation, die nach ca. 2 Minuten
' abgeschlossen ist.
' Mit dieser Erweiterung wird auch der Befehl RXD freigeschaltet der anzeigt, ob
' die Uhrzeit Synchronisiert ist.
' Verwendet wird er z.B. so:
'
' if RXD then goto SYNC
' if NOT RXD then goto UNSYNC

' In unserem Beispiel wird der BEEPER aktiviert wenn die Uhrzeit synchronisiert ist.
' Nach der Synchronisation luft die Uhrzeit mit RTC-Genauigkeit weiter, sodass
' Sie SYS DCFSYNC entsprechend den Anforderungen an die Genauigkeit der RTC hufiger
' aufrufen mssen.
'------------------------------------------------------------------------
'  !! Die Synchronisation beeinhaltet keine Korrektur von bertragungsfehlern !!
' Wenn Sie die Uhreit hundertprozentig sicher anzeigen zu wollen, mssen Sie
' fr eine Verifizierung mehrer Rahmen selbst Sorge tragen.
' In diesem Beispiel weden die empfangene Zeitinformation auf einfache Plausibilitt
' geprft, was in den meisten Fllen vllig ausreichend ist.
'------------------------------------------------------------------------
' Weitere Details zu dieser Systemerweiterung und DCF-Synchronisierung finden Sie
' im Beispiel DCF_SYNC.BAS
' Der Treiber fr den PCF8574 und das daran angeschlossene LCD ist in BASIC ausgefhrt
' Weiter Details dazu finden Sie im File APP_PCF8574_LCD.BAS.
'-----------------------------------------------------------------------
' SIE DRFEN DIESEN TREIBER NUR LADEN, WENN DIE PAGE0/1 NICHT VON ANDEREN
' TREIBERN/SYSTEMERWEITERUNGEN, DIE SIE BENTIGEN, BELEGT IST !
' Der Treiber ist nicht fr die MICRO mit der OS-Version 2.00 geeignet
'---------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'--- DCF INPUT -----------
define DCFIN    port[4]
define TASTER   port[3]
define BEEPER   port[6]

'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
'--- IIC INTERFACE  -------
define IICDATA      byte[1]
define OUTBYTE      byte[2]
define LCDDATA      byte[3]
define BUF          byte[4]
define WADDRESS     byte[5]
'---- PROGRAMM ------------
define COUNTER      byte[6]
'--- DEZIMAL CONVERTER ----
define value        byte[7]
define zehner       byte[9]
define einer        byte[10]
define OLD_SEC      byte[12]
define  a           byte[13]
define LCDADDR  &B01001110

'--------------------------
'---- SYSTEM JUMPS  -------
'--------------------------
define DCFSYNC &HFD09
SYS DCFSYNC
'---------- IICBUS INIT ------------------
SDA=on:SCL=on
pause 20
'---------- PCF8574 LCD INIT -------------
gosub lcd_init

HOUR=23:MINUTE=43
'--------------------------------------------------
'       MAKING A RADIO CONTROLLED CLOCK           -
'--------------------------------------------------

#WAITSEC
'------ WARTEN AUF SEKUNDENWECHSEL ----------------
if OLD_SEC = second then goto WAITSEC
'---------- ZEIT ANZEIGEN -------------------------
OLD_SEC=second
if RXD then gosub VERIFY
gosub SHOWTIME:goto WAITSEC

'--------- VERIFY TIME INFORMATION ---------------
#VERIFY
if (HOUR>24)or (MINUTE >59) then goto RESYNC
beep 100,5,BEEPER:return
#RESYNC
SYS DCFSYNC:return
'IIIIIIIIIIIII UNTERPROGRAMME IIIIIIIIIIIIIIIIIIIIIII
#SHOWTIME
LCDDATA=4:gosub L1_GOTOPOS
VALUE=HOUR:gosub MAKEDIGIT:LCDDATA=&H3A:gosub LCD_WRITECHAR
VALUE=MINUTE:gosub MAKEDIGIT:LCDDATA=&H3A:gosub LCD_WRITECHAR
VALUE=SECOND:gosub MAKEDIGIT
return


#MAKEDIGIT
zehner=value/10
LCDDATA=zehner+&H30:gosub LCD_WRITECHAR
einer=value-(zehner*10)
LCDDATA=einer+&H30:gosub LCD_WRITECHAR
return

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII




'HHHHHHHHHHH IIC-BUS LCD TREIBER HHHHHHHHHHH
'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=WADDRESS:gosub IICSEND
IICDATA=OUTBYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
SDA=(IICDATA and &H80)shr 7:SCL=on:SCL=off
SDA=(IICDATA and &H40)shr 6:SCL=on:SCL=off
SDA=(IICDATA and &H20)shr 5:SCL=on:SCL=off
SDA=(IICDATA and &H10)shr 4:SCL=on:SCL=off
SDA=(IICDATA and &H08)shr 3:SCL=on:SCL=off
SDA=(IICDATA and &H04)shr 2:SCL=on:SCL=off
SDA=(IICDATA and &H02)shr 1:SCL=on:SCL=off
SDA=(IICDATA and &H01):SCL=on:SCL=off
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
deact SDA:SCL=on:SCL=off:SDA=off:return

'---------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
WADDRESS=LCDADDR
OUTBYTE=0:gosub WRITEBYTE
LCDDATA=&H38:gosub LCD_WRITECMD
OUTBYTE= &B00000010:gosub WRITEBYTE '$02 to LCD
OUTBYTE= &B01000010:gosub WRITEBYTE '$02 with CLOCK
OUTBYTE= &B00000010:gosub WRITEBYTE
LCDDATA=&H28:gosub LCD_WRITECMD
LCDDATA=&H0C:gosub LCD_WRITECMD
#LCD_CLR
LCDDATA=&H02:gosub LCD_WRITECMD
LCDDATA=&H01:gosub LCD_WRITECMD
return
#L1_GOTOPOS
LCDDATA=LCDDATA +&H7F:goto LCD_WRITECMD
#L2_GOTOPOS
LCDDATA=LCDDATA +&HBF:goto LCD_WRITECMD
#LCD_WRITECMD
BUF = off:goto LCD_WRITE
#LCD_WRITECHAR
BUF = &B00100000
#LCD_WRITE
WADDRESS=LCDADDR
'--------- WRITE HI NIBBLE -------------
OUTBYTE=BUF or (LCDDATA shr 4):gosub WRITEBYTE      'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
'--------- WRITE LO NIBBLE -------------
OUTBYTE=BUF or (LCDDATA and &H0F):gosub WRITEBYTE'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
return
'---------------------------------------------
syscode "page0_ext1.s19"

